"use client"

import evalCode from "@/utils/transpile/evalCode"
import React, { useEffect, useState } from "react"

const defaultMain = `function dapp(){
    return <div></div>
  }`

function DApp({ dapp }: { dapp: string }) {
  const Comp: any = evalCode(`
    function _main() {
      ${dapp || defaultMain}
      return main()
    }
    return _main()
  `, {React, document})
  return <main>
    {Comp}
  </main>
}

export function Render({ dapp }: { dapp: string}) {
  const [isClient, setIsClient] = useState(false)
 
  useEffect(() => {
    setIsClient(true)
  }, [])
 
  return isClient ? (<DApp dapp={dapp} />) : <></>
  
}
