import React, { useEffect, useState } from 'react'
import "./index.css"
import { Account, CPChainExtensionWallet } from '@cpchain-foundation/wallets'

export default function main() {
  const [wallet] = React.useState(new CPChainExtensionWallet())
  const [account, setAccount] = React.useState<Account>()
  return <div className='flex flex-col gap-4 p-4'>
    <div className='logo'></div>
    <button onClick={() => {
      wallet.connect().then(account => {
        setAccount(account)
      }).catch(err => {
        console.error(err)
      })
    }} className='px-3 py-2 w-48 rounded-lg shadow-sm bg-green-700 text-gray-50 hover:bg-green-400 transition-all'>
      Connect wallet
    </button>
    <div className='flex flex-col gap-2'>
      <div className='flex flex-row gap-2'>
        <span>Address:</span>
        <span>{account?.address}</span>
      </div>
      <div className='flex flex-row gap-2'>
        <span>Chain:</span>
        {account && <span>{account?.chain.name}({account.chain.nodes[0]})</span>}
      </div>
    </div>
  </div>
}
